# CreateSecurityGroup

## 1. 接口描述

本接口(CreateSecurityGroup)用于创建安全组。

{% hint style="info" %}
**注意事项**

* 同一个Team能创建的安全组资源个数是有限制的，如果需要申请更多资源，请提交Support申请。
* 安全组的规则数量最多40条，入方向最多20条、出方向最多20条。
* 同一规则方向，规则不能重复。
  {% endhint %}

## 2. 请求参数

以下请求参数列表仅列出了接口中需要的请求参数

| 参数名称              | 必选 | 类型                                                                          | 描述                                                |
| ----------------- | -- | --------------------------------------------------------------------------- | ------------------------------------------------- |
| securityGroupName | 是  | String                                                                      | <p>安全组名称。</p><p>范围1到64个字符，仅支持字母、数字、-和英文句点(.)。</p> |
| ruleInfos         | 否  | Array of [RuleInfo](/api-reference/cn/compute/vm/datastructure.md#ruleinfo) | 安全组规则。                                            |
| description       | 否  | String                                                                      | <p>安全组描述。</p><p>范围2到256个字符。</p>                   |

## 3. 响应结果

| 参数名称            | 类型     | 描述                                                       |
| --------------- | ------ | -------------------------------------------------------- |
| requestId       | String | <p>唯一请求 ID。</p><p>每次请求都会返回。定位问题时需要提供该次请求的 requestId。</p> |
| securityGroupId | String | 安全组ID。                                                   |

## 4. 代码示例

{% tabs %}
{% tab title="示例" %}
**1. 创建安全组。**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateSecurityGroup
<Common Request Params>

Request:
{
  "securityGroupName": "test123",
  "ruleInfos": [
    {
      "direction": "ingress",
      "policy": "accept",
      "ipProtocol": "tcp",
      "portRange": "22/22",
      "cidrIp": "0.0.0.0/0"
    }
  ],
  "description": "123456"
}

Response:
{
  "requestId": "TA851AB85-577F-41BE-8E76-68171F021E36",
  "response": {
    "requestId": "TA851AB85-577F-41BE-8E76-68171F021E36",
    "securityGroupId": "your-security-group-id"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. 开发者工具

Zenlayer Cloud API 2.0 提供了配套的[开发工具集（SDK）](/api-reference/cn/api-introduction/toolkit.md)，未来会陆续支持更多开发语言，方便快速接入和使用Zenlayer的产品和服务。

## 6. 错误码

下面包含业务逻辑中遇到的错误码，其他错误码见[公共错误码](/api-reference/cn/api-introduction/instruction/commonerrorcode.md)

| HTTP状态码 | 错误码                                                       | 说明                     |
| ------- | --------------------------------------------------------- | ---------------------- |
| 400     | INVALID\_PARAMETER\_SECURITY\_GROUP\_RULE\_ID\_NOT\_ALLOW | 安全组规则ID不允许传。           |
| 400     | INVALID\_PARAMETER\_SECURITY\_GROUP\_POLICY               | 安全组规则Policy参数错误。       |
| 400     | INVALID\_PARAMETER\_SECURITY\_GROUP\_PORT\_RANGE          | 安全组规则PortRange参数错误。    |
| 400     | INVALID\_PARAMETER\_SECURITY\_GROUP\_PRIORITY             | 安全组规则Priority参数错误。     |
| 400     | INVALID\_PARAMETER\_SECURITY\_GROUP\_SOURCE\_CIDR\_IP     | 安全组规则SourceCidrIp参数错误。 |
| 403     | OPERATION\_DENIED\_SECURITY\_GROUP\_EXIST\_REPEAT\_RULE   | 安全组规则存在重复。             |
| 403     | OPERATION\_DENIED\_SECURITY\_GROUP\_RULE\_EXCEED\_LIMIT   | 安全组规则超过限制。             |
| 403     | OPERATION\_DENIED\_SECURITY\_GROUP\_TEAM\_EXCEED\_LIMIT   | 该Team安全组超过限制。          |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/cn/compute/vm/security-group/createsecuritygroup.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
